/*
 * Copyright 2012 ETH Zuerich, CISD
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ch.systemsx.cisd.openbis.uitest.gui;

import ch.systemsx.cisd.openbis.uitest.dsl.Command;
import ch.systemsx.cisd.openbis.uitest.dsl.Inject;
import ch.systemsx.cisd.openbis.uitest.layout.AssignSamplePropertyLocation;
import ch.systemsx.cisd.openbis.uitest.page.AssignSamplePropertyType;
import ch.systemsx.cisd.openbis.uitest.type.PropertyTypeAssignment;
import ch.systemsx.cisd.openbis.uitest.webdriver.Pages;

/**
 * @author anttil
 */
public class CreatePropertyTypeAssignmentGui implements Command<PropertyTypeAssignment>
{

    @Inject
    private Pages pages;

    private PropertyTypeAssignment assignment;

    public CreatePropertyTypeAssignmentGui(PropertyTypeAssignment assignment)
    {
        this.assignment = assignment;
    }

    @Override
    public PropertyTypeAssignment execute()
    {
        AssignSamplePropertyType assign = pages.goTo(new AssignSamplePropertyLocation());
        assign.fillWith(assignment);
        assign.save();
        return assignment;
    }

}
